/* ----------------------------------------------------------
	C H A N G E    L O G
	April-17-2015
		Looked at the file format
		header is a container, there are 2 sub blocks
		one is model, the other is texture
		
		the model block has sub blocks
		the model sub block header
		IS NOT COMPLETED
		
		but reading the model block component table
		addresses, and sub blocks
		
		Basic geomety Imported
	- mariokart64n

*/ ----------------------------------------------------------
global f,g,PS3_WANGANM_IMPORTER,mscale=((1.0/2.54)*100),impMsh=true,dumpTex = false,guiEnabled=true

struct _geometry (
	position=#(),
	uv_coordinate=#(),
	matid=#(),
	matcount=#(),
	face=#()
	)
struct _XTD_header (
	fileid="",
	vers=0,
	unk1="",
	offsets=#()
	)
struct _header (
	fileid = "",
	filever = 0,
	unk1 = "",
	unk2 = 0,
	count = 0,
	offsets=#(),
	sizes=#()
	)
struct _subheader (
	type=0,
	string_index=0,
	size=0,
	unk2=0,
	unk3=0
	)
struct _filetable (
	unk1=0,
	unk2=0,
	unk3=0,
	offsets = #()
	)
fn RH2LH corrd = (
	[corrd.x,-corrd.z,corrd.y]*mscale
	)
fn readBEfloat fstream = (
	bit.intAsFloat (bit.swapBytes (bit.swapBytes (readlong fstream #unsigned) 1 4) 2 3)
	)
fn readBElong fstream = (
	bit.swapBytes (bit.swapBytes (readlong fstream #unsigned) 1 4) 2 3
	)
fn readBEshort fstream = (
	bit.swapBytes (readshort fstream #unsigned) 1 2
	)
fn getpadding num alignment = (
	mod (alignment-(mod num alignment)) alignment
	)
fn paddstring len instring = (
	local i,str=""
	instring=instring as string
	if instring.count <=len then (
		for i = 1 to (len-instring.count) do (
			str+="0"
			)
		str = (str+instring)
		)
	else (
		for i = 1 to len do (
			str+="0";str[i]=instring[i]
			)
		)
	return str
	)
fn readFixedString bstream fixedLen = (
	local i,str = ""
	for i = 1 to fixedLen do (
		str += bit.intAsChar (ReadByte bstream #unsigned)
		)
	str
	)
fn triangle_strip fstream count = (
	global g
	local face_add=1,matid=1,vertex_start=0
	local count,fa,fb,fc,x,y
	local face_flip = true
	local face_reset=true
	x=0;while x< count do (
		x+=1
		if face_reset == true then (
			x+=2
			face_reset=false
			face_flip = false
			append g.matid matid
			fa = ((readBEshort fstream)-vertex_start) + face_add
			fb = ((readBEshort fstream)-vertex_start) + face_add
			fc = ((readBEshort fstream)-vertex_start) + face_add
			if face_flip == true then (
				append g.face [fa,fc,fb];face_flip=false
				)
			else(
				append g.face [fa,fb,fc];face_flip=true
				)
			)
		else(
			fa = fb;fb = fc;fc = readBEshort fstream
			if fc<0xFFFF then (
				fc-= vertex_start
				fc += face_add
				append g.matid matid
				if face_flip == true then (
					append g.face [fa,fc,fb];face_flip=false
					)
				else(
					append g.face [fa,fb,fc];face_flip=true
					)
				)
			else(
				face_reset=true
				)
			)
		)
	)
fn buildObj objname = (
	global g
	local j,msh--,mats = copy g.matcount #nomap
-- 	local faceValid = true
-- 	j=1;while j < g.face.count and faceValid == true do (
-- 		if g.face[j][1] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		if g.face[j][2] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		if g.face[j][3] > g.position.count or g.face[j][1] < 0 do faceValid = false
-- 		j+=1
-- 		)
-- 	if faceValid == false do (g.face = #();print "Face Range Error")
-- 	print g.position.count
-- 	print g.face
	if g.position.count>0 do (
		msh = mesh vertices:g.position tverts:g.uv_coordinate faces:g.face-- materialIDs:g.matid
		msh.name = objname
		msh.numTVerts = g.uv_coordinate.count
		msh.displayByLayer = false
		msh.backfacecull = on
		buildTVFaces msh
-- 		
		for j = 1 to g.uv_coordinate.count do setTVert msh j g.uv_coordinate[j]
		for j = 1 to g.face.count do setTVFace msh j g.face[j]
			convertTo msh PolyMeshObject
-- 		if g.matcount.count > 0 do (
-- 		msh.material = multiMaterial numsubs:g.matcount.count
-- 			sort mats
-- 			for j = 1 to g.matcount.count do (
-- 				msh.material.materialList[j].Diffuse = random (color 0 0 0) (color 255 255 255)
-- 				msh.material.materialList[j].diffuseMap = Bitmaptexture fileName:("tex_"+(paddstring 3 (findItem mats g.matcount[j]))+".tga")
-- 				)
-- 			)
		)
	msh
	)
fn writeDDSheader fstream texW texH texM texC = (
	local texP=0,i
	writelong fstream 0x20534444 #unsigned -- File ID
	writelong fstream 0x7C #unsigned -- Header Size
	case texC of ( -- dwFlags
		"DXT1": (
			writelong fstream 0x00081007 #unsigned
			texP=((texW*texH)/0x02)
			)
		"DXT3": (
			writelong fstream 0x00081007 #unsigned
			texP=(texW*texH)
			)
		"DXT5": (
			writelong fstream 0x00081007 #unsigned
			texP=(texW*texH)
			)
		"ATI1": (
			writelong fstream 0x000A1007 #unsigned
			texP=((texW*texH)/0x20)
			)
		"ATI2": (
			writelong fstream 0x000A1007 #unsigned
			texP=(texW*texH)
			)
		"P8": (
			writelong fstream 0x000A1007 #unsigned
			texP=((texW*texH)/0x02)
			)
		"ARGB16": (
			writelong fstream 0x00081007 #unsigned
			texP=(((texW*texH)/0x8)*0x10)
			)
		"ARGB32": (
			writelong fstream 0x00081007 #unsigned
			texP=(((texW*texH)/0x4)*0x10)
			)
		)
	writelong fstream texW #unsigned -- Texture Width
	writelong fstream texH #unsigned -- Texture Height
	writelong fstream texP #unsigned -- Pitch (#of bytes in a single row across the texture)
	writelong fstream 0x00 #unsigned -- Image Depth? Not Used, for Image Volume
	writelong fstream texM #unsigned -- Texture MIP Count
	for i = 1 to 11 do (
		writelong fstream 0x00 #unsigned
		) -- Reserved Space
	writelong fstream 0x20 #unsigned -- Size of PIXEL_FORMAT info, always 32bytes;
	case texC of (
		"DXT1": (
			writelong fstream 0x04;writelong fstream 0x31545844 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00001000 #unsigned
			)
		"DXT3": (
			writelong fstream 0x04;writelong fstream 0x33545844 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00001000 #unsigned
			)
		"DXT5": (
			writelong fstream 0x04;writelong fstream 0x35545844 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00001000 #unsigned
			)
		"ATI1": (
			writelong fstream 0x04;writelong fstream 0x31495441 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00401008 #unsigned
			)
		"ATI2": (
			writelong fstream 0x04;writelong fstream 0x32495441 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00401008 #unsigned
			)
		"P8": (
			writelong fstream 0x20;writelong fstream 0x20203850 #unsigned
			writelong fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00401008 #unsigned
			)
		"ARGB16": (
			writelong fstream 0x41;writelong fstream 0x00000000 #unsigned
			writelong fstream 0x10;writebyte fstream 0x00;writebyte fstream 0x0F;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0xF0;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x0F;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0xF0;writebyte fstream 0x00
			writebyte fstream 0x00;writelong fstream 0x00001000 #unsigned
			)
		"ARGB32": (
			writelong fstream 0x41;writelong fstream 0x00000000 #unsigned
			writelong fstream 0x20;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0xFF
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0xFF;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0xFF;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00;writebyte fstream 0x00
			writebyte fstream 0xFF;writelong fstream 0x00001000 #unsigned
			)
		)
	for i = 1 to 4 do ( -- Reserved Space for CAPS
		writelong fstream 0x00 #unsigned
		)
	)
fn getHeader = (
	global f
	local h = _header(),i=0,p=ftell f
	h.fileid = readFixedString f 3
	h.filever = readbyte f #unsinged
	h.unk1 = readFixedString f 4
	h.unk2 = readBElong f
	h.count = readBElong f
	h.offsets = (
		for i = 1 to h.count collect (
			readBElong f + p
			)
		)
	fseek f (getpadding (ftell f) 16) #seek_cur
	h.sizes = (
		for i = 1 to h.count collect (
			readBElong f
			)
		)
	fseek f (getpadding (ftell f) 16) #seek_cur
	h
	)
fn getSubHeader = (
	global f
	local s = _subheader()
	s.type = readBEshort f
	s.string_index = readBEshort f
	s.size = readBElong f
	s.unk2 = readBElong f
	s.unk3 = readBElong f
	s
	)
fn getTXD_header = (
	global f
	local t = _XTD_header(),p=ftell f
	t.fileid = readFixedString f 3
	t.vers = readbyte f #unsigned
	t.unk1 = readFixedString f 4
	t.offsets = (
		for i = 1 to (readlong f #unsigned) collect (
			readlong f #unsigned + p
			)
		)
	t
	)
fn dumpGFT spath = (
	global f
	local p=ftell f
	local s
	if (readlong f #unsigned) == 0x00000501 and dumpTex==true then (
		readBElong f
		readBElong f
		readBElong f
		data_address = readBElong f + p
		data_size = readBElong f
		fmt = readbyte f #unsigned
		fseek f 0x03 #seek_cur
		readBElong f
		w = readBEshort f
		h = readBEshort f
		fseek f data_address #seek_set
		s = fopen spath "wb"
		writeDDSheader s h w 0 (
			case fmt of (
				0x86: ("DXT1")
				0x87: ("DXT3")
				0xA7: ("DXT3")
				default: (
					format "New DDS Type: 0x%\n" (bit.intAsHex((fmt)as integer))
					"DXT1"
					)
				)
			)
		for x = 1 to data_size do (
			writebyte s (readbyte f #unsigned) #unsigned
			)
		fclose s
		)
	else (
		if dumpTex == true do (
			format "Error: Unknown GFT Block\n"
			)
		)
	)
fn getTXD hdr fpath = (
	for i = 1 to hdr.offsets.count do (
		fseek f hdr.offsets[i] #seek_set
		size = readlong f #unsigned
		type = readlong f #unsigned
		unk1 = readBEshort f
		unk2 = readBEshort f
		unk3 = readBEshort f
		unk4 = readBEshort f
		if size > 0x10 do (
			print (fpath + "_tex_" + (paddstring 3 i) + ".dds")
			dumpGFT(fpath + "_tex_" + (paddstring 3 i) + ".dds")
			)
		)
	)
fn getType08 objname = ( -- geomety data
	global f,g = _geometry()
	local p = ftell f,getPos
-- 	format "GEO @ 0x%\n" (bit.intAsHex((ftell f)as integer))
	
	readBElong f
	readBElong f
	readBElong f
	readBElong f
	
	[(readBEfloat f),(readBEfloat f),(readBEfloat f),(readBEfloat f)]
	[(readBEfloat f),(readBEfloat f),(readBEfloat f),(readBEfloat f)]
	
	readBElong f
	readBElong f
	count1 = readBElong f
	count2 = readBElong f
	
	readBElong f
	readBElong f
	readBElong f
	readBElong f
	
	for i = 1 to count2 do (
		getPos = ftell f
		
		readBElong f -- 0x000A0000
		block_size = readBElong f
		comp = readBElong f
		datatype = readBElong f
		
		readBElong f
		count = readBElong f
		readBElong f
		readBElong f
		
		case comp of (
			0x00: ( -- face
				triangle_strip f count
				)
			0x02: ( -- position
				for i = 1 to count do (
					append g.position (RH2LH([(readBEfloat f),(readBEfloat f),(readBEfloat f)]))
					)
				)
			0x03: ( -- colours
				)
			0x04: ( -- normals
				)
			0x05: ( -- UVs
				for i = 1 to count do (
					append g.uv_coordinate ([(readBEfloat f),1-(readBEfloat f),0])
					)
				)
			default: (
				format "Error Vertex Format Unsupported [%] @ 0x%\n" \
					comp (bit.intAsHex((getPos)as integer))
				)
			)
		fseek f (getPos + block_size) #seek_set
		)
-- 		print g.uv_coordinate.count
	if g.uv_coordinate.count < g.position.count do (
		
		for i = 1 to (g.position.count - g.uv_coordinate.count) do (
			append g.uv_coordinate [0,0,0]
			)
		)
		
	buildObj(objname)
	)
fn getType21 = ( -- string data
	global f
	readstring f
	)
fn get_stuff_table pos = (
	global f
	local t = _filetable()
	t.unk1=readBElong f
	t.unk2=readBElong f
	t.unk3=readBElong f
	t.offsets = (
		for i = 1 to t.unk2 collect (
			readBElong f + pos
			)
		)
	t
	)
fn getStuff pos = (
	global f
	local p=ftell f,strArray=#()
	fseek f 0x80 #seek_cur -- FIX ME
	
	-- HEADER HERE DESCRIBES COUNTS FOR DATA BELOW
	check = readlong f #unsigned
	if check == 0x00007042 or check == 0x0000F041 then (
		table = get_stuff_table(pos)
		for i = 1 to table.unk2 do (
			fseek f table.offsets[i] #seek_set
			sb=getSubHeader()
			if sb.type == 0x15 do (
				append strArray ( getType21() )
				)
			)
		for i = 1 to table.unk2 do (
			fseek f table.offsets[i] #seek_set
			sb=getSubHeader()
			case sb.type of (
				0x04: (
					if guiEnabled == false do (format "Matrix? @ 0x%\n" (bit.intAsHex((table.offsets[i])as integer)))
					) -- matrix?
				0x05: (
					if guiEnabled == false do (format "Bound Box @ 0x%\n" (bit.intAsHex((table.offsets[i])as integer)))
					) -- bounding box
				0x07: (
					if guiEnabled == false do (format "Material @ 0x%\n" (bit.intAsHex((table.offsets[i])as integer)))
					) -- materials
				0x08: ( -- geometry
					if guiEnabled == false do (format "Geometry @ 0x%\n" (bit.intAsHex((table.offsets[i])as integer)))
					if impMsh == true do (
						getType08((filterstring (strArray[(sb.string_index)]) ".")[1])
						)
					)
				0x0C: (
					if guiEnabled == false do (format "BoneMap ? @ 0x%\n" (bit.intAsHex((table.offsets[i])as integer)))
					) -- ? bonemapping
				0x15: ( -- string data
					)
				default: (
					format "SubBlock Not Supported [%] @ 0x%\n" \
						sb.type (bit.intAsHex((table.offsets[i])as integer))
					)
				)
			)
		)
	else (
		format "Error: Failed to seek to table\n"
		)
	)	
fn readBinary filen = (
	global f
	local magic = readlong f #unsigned
	fseek f -4 #seek_cur
	case magic of (
		0x01444D58: ( -- XMD (Xtreme Model Data)
			hdr = getHeader()
			for d = 1 to hdr.count do (
				fseek f hdr.offsets[d] #seek_set
				filetype = readlong f #unsigned
				fseek f hdr.offsets[d] #seek_set
				case filetype of (
					0x00000000: (
						getStuff(hdr.offsets[d])
						)
					0x01444D58: (
						readBinary(filen)
						)
					0x00445458: ( -- XTD
						getTXD( getTXD_header() )((getFilenamePath filen)+(getFilenameFile filen))
						)
					default: (
						format "Error: New Block Type [%] @ Address: 0x%\n" \
							filetype (bit.intAsHex((hdr.offsets[d])as integer))
						)
					)
				)
			)
		0x00445458: ( -- XTD (Xtreme Texture Data)
			getTXD( getTXD_header() )((getFilenamePath filen)+(getFilenameFile filen))
			)
		0x00000501: ( -- GTF
			dumpGFT((getFilenamePath filen)+(getFilenameFile filen)+"_tex_001.dds")
			)
		)
	format "Last Read @ 0x%\n" (bit.intAsHex((ftell f)as integer))
	)
clearlistener()
if guiEnabled == false then (
	filen = "C:\\Users\\Corey\\Desktop\\Wangan Midnight\\WanganMidnightDATA\\COURSE\\BAGOAL\\SB_START.MDL"

-- 	filen = GetOpenFileName \
-- 	caption:"Select GRID File" \
-- 	types: "Wangan Midnight files (*.*)|*.*|"
	if filen!=undefined and doesFileExist filen == true then (
		try(fclose f)catch(gc())
		f = fopen filen "rb"
		readBinary(filen)
		fclose f
		)
	else (
		format "Aborted\n"
		)
	)
else (
	try(destroydialog PS3_WANGANM_IMPORTER)catch()
	rollout PS3_WANGANM_IMPORTER "Wangan Midnight" (
		group "Main" (
			button btn1 "IMPORT" width:65 height:31 align:#center
			label ls0 ""  -- spacer
			checkbox chk1 "Clear Scene     " checked:true align:#center
			checkbox chk3 "Import Mesh    " checked:true align:#center
			checkbox chk2 "Dump Textures" checked:false align:#center
			)
		group "About" (
			hyperLink lb5 "Author:  mariokart64n" address:"mailto:mario_kart64n@hotmail.com"
			label lb3 "Date:      April 2015" align:#left
			hyperLink lb7 "Donate:  Paypal" address:"https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=coreynguyen%40gmail%2ecom&item_name=maxscript%20work&no_shipping=0&no_note=1&tax=0&currency_code=CAD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8"
			)
		on chk2 changed theState do (
			dumpTex = theState
			)
		on chk3 changed theState do (
			impMsh = theState
			)
		on PS3_WANGANM_IMPORTER open do (
			chk2.checked = dumpTex
			chk3.checked = impMsh
			)
		on btn1 pressed do (
			filen = GetOpenFileName \
			caption:"Select GRID File" \
			types: "Wangan Midnight files (*.*)|*.*|"
			if filen!=undefined and doesFileExist filen == true then (
				try(fclose f)catch(gc())
				f = fopen filen "rb"
				if chk1.checked == true do (
					delete $*
					)
				readBinary(filen)
				messagebox "Done!"
				format "Last Read @ 0x%\n" (bit.intAsHex((ftell f)as integer))
				fclose f
				)
			else (
				format "Aborted\n"
				)
			)
		)
	createdialog PS3_WANGANM_IMPORTER
	)